#!/usr/bin/php
<?php
error_reporting(E_ALL);

/* Позволяет скрипту ожидать соединения бесконечно. */
set_time_limit(0);

/* Включает скрытое очищение вывода так, что мы получаем данные
 * как только они появляются. */
ob_implicit_flush();

$address = '10.128.0.148';
$port = 4355;

if (($sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP)) === false) {
    echo "Не удалось выполнить socket_create(): причина: " . socket_strerror(socket_last_error()) . "\n";
}

if (socket_bind($sock, $address, $port) === false) {
    echo "Не удалось выполнить socket_bind(): причина: " . socket_strerror(socket_last_error($sock)) . "\n";
}

if (socket_listen($sock, 5) === false) {
    echo "Не удалось выполнить socket_listen(): причина: " . socket_strerror(socket_last_error($sock)) . "\n";
}

$az = 10;
do {
    if (($msgsock = socket_accept($sock)) === false) {
        echo "Не удалось выполнить socket_accept(): причина: " . socket_strerror(socket_last_error($sock)) . "\n";
        break;
    }
    /* Отправляем инструкции. */

//    $msg = "\nДобро пожаловать на тестовый сервер PHP. \n" .
//        "Чтобы отключиться, наберите 'выход'. Чтобы выключить сервер, наберите 'выключение'.\n";
//    socket_write($msgsock, $msg, strlen($msg));

    do {
        if (false === ($buf = socket_read($msgsock, 2048, PHP_NORMAL_READ))) {
            echo "Не удалось выполнить socket_read(): причина: " . socket_strerror(socket_last_error($msgsock)) . "\n";
            break 2;
        }
        if (!$buf = trim($buf)) {
            continue;
        }
        if ($buf == 'выход') {
            break;
        }
        if ($buf == 'выключение') {
            socket_close($msgsock);
            break 2;
        }

        if (preg_match('/^P/',$buf)) { // get AZ EL
         $a = preg_split('/ +/',$buf);
         $az = $a[1];
         $el = $a[2];
         sendAZEL($az,$el);
         echo "Send: $az $el\n";
        }
 
        if ($buf=='p') { // get AZ EL
         $talkback = getAZEL();
         echo "Get: $talkback";
        } else {
         $talkback = "OK\n";
        }

         socket_write($msgsock, $talkback, strlen($talkback));

         // echo "$buf\n";

    } while (true);
    socket_close($msgsock);
} while (true);

socket_close($sock);

function sendAZEL($az,$el) {

 $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
 $result = socket_connect($socket, "20.20.20.29",4355);

 $AZEL = "AZ".$az." EL".$el."\r\n";

 if ($result === false) return(0);

 socket_write($socket, $AZEL, strlen($AZEL)); 
 socket_close($socket);

}

function getAZEL() {

 $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
 $result = socket_connect($socket, "20.20.20.29",4355);

 $AZEL = "AZ EL\r\n";

 if ($result === false) return(0);

 socket_write($socket, $AZEL, strlen($AZEL)); 

 $buf = socket_read($socket, 2048);

 if (!empty($buf)) {
  $azel = preg_split('/ +/',$buf);
  $az = substr($azel[0],2);
  $el = substr($azel[1],2);
  $val = $az."\n".$el."\n";
 } else {
  $val = "ok\n";
 }
 
 socket_close($socket);

 return($val);

}

?>

